# GstElementFactory

GstElementFactory is used to create instances of elements. A GstElementFactory can be added to a GstPlugin as it is also a GstPluginFeature.

Use the gst_element_factory_find and gst_element_factory_create functions to create element instances or use gst_element_factory_make as a convenient shortcut.

The following code example shows you how to create a GstFileSrc element.

## Using an element factory

       #include <gst/gst.h>

       GstElement *src;
       GstElementFactory *srcfactory;

       gst_init (&argc, &argv);

       srcfactory = gst_element_factory_find ("filesrc");
       g_return_if_fail (srcfactory != NULL);
       src = gst_element_factory_create (srcfactory, "src");
       g_return_if_fail (src != NULL);
       ...

## GstElementFactory

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstPluginFeature
                    ╰──GstElementFactory

The opaque GstElementFactory data structure.

### Class structure

#### GstElementFactoryClass

### Gst.ElementFactoryClass

## Gst.ElementFactory

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.PluginFeature
                    ╰──Gst.ElementFactory

The opaque Gst.ElementFactory data structure.

## Gst.ElementFactory

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.PluginFeature
                    ╰──Gst.ElementFactory

The opaque Gst.ElementFactory data structure.

### Methods

#### gst_element_factory_can_sink_all_caps

    gboolean
    gst_element_factory_can_sink_all_caps (GstElementFactory * factory,
                                           const GstCaps * caps)

Checks if the factory can sink all possible capabilities.

Parameters:

`factory` –

factory to query

`caps` –

the caps to check

Returns –

TRUE if the caps are fully compatible.

#### Gst.ElementFactory.prototype.can_sink_all_caps

    function Gst.ElementFactory.prototype.can_sink_all_caps(caps: Gst.Caps): {
        // javascript wrapper for 'gst_element_factory_can_sink_all_caps'
    }

Checks if the factory can sink all possible capabilities.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (Number) –

true if the caps are fully compatible.

#### Gst.ElementFactory.can_sink_all_caps

    def Gst.ElementFactory.can_sink_all_caps (self, caps):
        #python wrapper for 'gst_element_factory_can_sink_all_caps'

Checks if the factory can sink all possible capabilities.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (bool) –

True if the caps are fully compatible.

#### gst_element_factory_can_sink_any_caps

    gboolean
    gst_element_factory_can_sink_any_caps (GstElementFactory * factory,
                                           const GstCaps * caps)

Checks if the factory can sink any possible capability.

Parameters:

`factory` –

factory to query

`caps` –

the caps to check

Returns –

TRUE if the caps have a common subset.

#### Gst.ElementFactory.prototype.can_sink_any_caps

    function Gst.ElementFactory.prototype.can_sink_any_caps(caps: Gst.Caps): {
        // javascript wrapper for 'gst_element_factory_can_sink_any_caps'
    }

Checks if the factory can sink any possible capability.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (Number) –

true if the caps have a common subset.

#### Gst.ElementFactory.can_sink_any_caps

    def Gst.ElementFactory.can_sink_any_caps (self, caps):
        #python wrapper for 'gst_element_factory_can_sink_any_caps'

Checks if the factory can sink any possible capability.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (bool) –

True if the caps have a common subset.

#### gst_element_factory_can_src_all_caps

    gboolean
    gst_element_factory_can_src_all_caps (GstElementFactory * factory,
                                          const GstCaps * caps)

Checks if the factory can src all possible capabilities.

Parameters:

`factory` –

factory to query

`caps` –

the caps to check

Returns –

TRUE if the caps are fully compatible.

#### Gst.ElementFactory.prototype.can_src_all_caps

    function Gst.ElementFactory.prototype.can_src_all_caps(caps: Gst.Caps): {
        // javascript wrapper for 'gst_element_factory_can_src_all_caps'
    }

Checks if the factory can src all possible capabilities.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (Number) –

true if the caps are fully compatible.

#### Gst.ElementFactory.can_src_all_caps

    def Gst.ElementFactory.can_src_all_caps (self, caps):
        #python wrapper for 'gst_element_factory_can_src_all_caps'

Checks if the factory can src all possible capabilities.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (bool) –

True if the caps are fully compatible.

#### gst_element_factory_can_src_any_caps

    gboolean
    gst_element_factory_can_src_any_caps (GstElementFactory * factory,
                                          const GstCaps * caps)

Checks if the factory can src any possible capability.

Parameters:

`factory` –

factory to query

`caps` –

the caps to check

Returns –

TRUE if the caps have a common subset.

#### Gst.ElementFactory.prototype.can_src_any_caps

    function Gst.ElementFactory.prototype.can_src_any_caps(caps: Gst.Caps): {
        // javascript wrapper for 'gst_element_factory_can_src_any_caps'
    }

Checks if the factory can src any possible capability.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (Number) –

true if the caps have a common subset.

#### Gst.ElementFactory.can_src_any_caps

    def Gst.ElementFactory.can_src_any_caps (self, caps):
        #python wrapper for 'gst_element_factory_can_src_any_caps'

Checks if the factory can src any possible capability.

Parameters:

`factory` (Gst.ElementFactory) –

factory to query

`caps` (Gst.Caps) –

the caps to check

Returns (bool) –

True if the caps have a common subset.

#### gst_element_factory_create

    GstElement *
    gst_element_factory_create (GstElementFactory * factory,
                                const gchar * name)

Create a new element of the type defined by the given elementfactory. It will be given the name supplied, since all elements require a name as their first argument.

Parameters:

`factory` –

factory to instantiate

`name` ( [nullable]) –

name of new element, or NULL to automatically create a unique name

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if the element couldn't be created

#### Gst.ElementFactory.prototype.create

    function Gst.ElementFactory.prototype.create(name: String): {
        // javascript wrapper for 'gst_element_factory_create'
    }

Create a new element of the type defined by the given elementfactory. It will be given the name supplied, since all elements require a name as their first argument.

Parameters:

`factory` (Gst.ElementFactory) –

factory to instantiate

`name` (String) –

name of new element, or null to automatically create a unique name

Returns (Gst.Element) –

new Gst.Element or null if the element couldn't be created

#### Gst.ElementFactory.create

    def Gst.ElementFactory.create (self, name):
        #python wrapper for 'gst_element_factory_create'

Create a new element of the type defined by the given elementfactory. It will be given the name supplied, since all elements require a name as their first argument.

Parameters:

`factory` (Gst.ElementFactory) –

factory to instantiate

`name` (str) –

name of new element, or None to automatically create a unique name

Returns (Gst.Element) –

new Gst.Element or None if the element couldn't be created

#### gst_element_factory_create_full

    GstElement *
    gst_element_factory_create_full (GstElementFactory * factory,
                                     const gchar * first,
                                     ... ...)

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factory` –

factory to instantiate

`first` ( [nullable]) –

name of the first property

`...` ( [nullable]) –

NULL terminated list of properties

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if the element couldn't be created

Since : 1.20

#### gst_element_factory_create_valist

    GstElement *
    gst_element_factory_create_valist (GstElementFactory * factory,
                                       const gchar * first,
                                       va_list properties)

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factory` –

factory to instantiate

`first` ( [nullable]) –

name of the first property

`properties` ( [nullable]) –

list of properties

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if the element couldn't be created

Since : 1.20

#### gst_element_factory_create_with_properties

    GstElement *
    gst_element_factory_create_with_properties (GstElementFactory * factory,
                                                guint n,
                                                const gchar ** names,
                                                const GValue * values)

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factory` –

factory to instantiate

`n` –

count of properties

`names` ( [nullable][array length=n]) –

array of properties names

`values` ( [nullable][array length=n]) –

array of associated properties values

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if the element couldn't be created

Since : 1.20

#### Gst.ElementFactory.prototype.create_with_properties

    function Gst.ElementFactory.prototype.create_with_properties(n: Number, names: [ String ], values: [ GObject.Value ]): {
        // javascript wrapper for 'gst_element_factory_create_with_properties'
    }

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factory` (Gst.ElementFactory) –

factory to instantiate

`n` (Number) –

count of properties

`names` ([ String ]) –

array of properties names

`values` ([ GObject.Value ]) –

array of associated properties values

Returns (Gst.Element) –

new Gst.Element or null if the element couldn't be created

Since : 1.20

#### Gst.ElementFactory.create_with_properties

    def Gst.ElementFactory.create_with_properties (self, n, names, values):
        #python wrapper for 'gst_element_factory_create_with_properties'

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factory` (Gst.ElementFactory) –

factory to instantiate

`n` (int) –

count of properties

`names` ([ str ]) –

array of properties names

`values` ([ GObject.Value ]) –

array of associated properties values

Returns (Gst.Element) –

new Gst.Element or None if the element couldn't be created

Since : 1.20

#### gst_element_factory_get_element_type

    GType
    gst_element_factory_get_element_type (GstElementFactory * factory)

Get the GType for elements managed by this factory. The type can only be retrieved if the element factory is loaded, which can be assured with gst_plugin_feature_load.

Parameters:

`factory` –

factory to get managed GType from

Returns –

the GType for elements managed by this factory or 0 if the factory is not loaded.

#### Gst.ElementFactory.prototype.get_element_type

    function Gst.ElementFactory.prototype.get_element_type(): {
        // javascript wrapper for 'gst_element_factory_get_element_type'
    }

Get the GObject.Type for elements managed by this factory. The type can only be retrieved if the element factory is loaded, which can be assured with Gst.PluginFeature.prototype.load.

Parameters:

`factory` (Gst.ElementFactory) –

factory to get managed GObject.Type from

Returns (GObject.Type) –

the GObject.Type for elements managed by this factory or 0 if the factory is not loaded.

#### Gst.ElementFactory.get_element_type

    def Gst.ElementFactory.get_element_type (self):
        #python wrapper for 'gst_element_factory_get_element_type'

Get the GObject.Type for elements managed by this factory. The type can only be retrieved if the element factory is loaded, which can be assured with Gst.PluginFeature.load.

Parameters:

`factory` (Gst.ElementFactory) –

factory to get managed GObject.Type from

Returns (GObject.Type) –

the GObject.Type for elements managed by this factory or 0 if the factory is not loaded.

#### gst_element_factory_get_metadata

    const gchar *
    gst_element_factory_get_metadata (GstElementFactory * factory,
                                      const gchar * key)

Get the metadata on factory with key.

Parameters:

`factory` –

a GstElementFactory

`key` –

a key

Returns ( [nullable]) –

the metadata with key on factory or NULL when there was no metadata with the given key.

#### Gst.ElementFactory.prototype.get_metadata

    function Gst.ElementFactory.prototype.get_metadata(key: String): {
        // javascript wrapper for 'gst_element_factory_get_metadata'
    }

Get the metadata on factory with key.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

`key` (String) –

a key

Returns (String) –

the metadata with key on factory or null when there was no metadata with the given key.

#### Gst.ElementFactory.get_metadata

    def Gst.ElementFactory.get_metadata (self, key):
        #python wrapper for 'gst_element_factory_get_metadata'

Get the metadata on factory with key.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

`key` (str) –

a key

Returns (str) –

the metadata with key on factory or None when there was no metadata with the given key.

#### gst_element_factory_get_metadata_keys

    gchar **
    gst_element_factory_get_metadata_keys (GstElementFactory * factory)

Get the available keys for the metadata on factory.

Parameters:

`factory` –

a GstElementFactory

Returns –

(transfer full) (element-type utf8) (array zero-terminated=1) (nullable): a NULL-terminated array of key strings, or NULL when there is no metadata. Free with g_strfreev when no longer needed.

#### Gst.ElementFactory.prototype.get_metadata_keys

    function Gst.ElementFactory.prototype.get_metadata_keys(): {
        // javascript wrapper for 'gst_element_factory_get_metadata_keys'
    }

Get the available keys for the metadata on factory.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns ([ String ]) –

(transfer full) (element-type utf8) (array zero-terminated=1) (nullable): a null-terminated array of key strings, or null when there is no metadata. Free with GLib.prototype.strfreev when no longer needed.

#### Gst.ElementFactory.get_metadata_keys

    def Gst.ElementFactory.get_metadata_keys (self):
        #python wrapper for 'gst_element_factory_get_metadata_keys'

Get the available keys for the metadata on factory.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns ([ str ]) –

(transfer full) (element-type utf8) (array zero-terminated=1) (nullable): a None-terminated array of key strings, or None when there is no metadata. Free with GLib.strfreev when no longer needed.

#### gst_element_factory_get_num_pad_templates

    guint
    gst_element_factory_get_num_pad_templates (GstElementFactory * factory)

Gets the number of pad_templates in this factory.

Parameters:

`factory` –

a GstElementFactory

Returns –

the number of pad_templates

#### Gst.ElementFactory.prototype.get_num_pad_templates

    function Gst.ElementFactory.prototype.get_num_pad_templates(): {
        // javascript wrapper for 'gst_element_factory_get_num_pad_templates'
    }

Gets the number of pad_templates in this factory.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns (Number) –

the number of pad_templates

#### Gst.ElementFactory.get_num_pad_templates

    def Gst.ElementFactory.get_num_pad_templates (self):
        #python wrapper for 'gst_element_factory_get_num_pad_templates'

Gets the number of pad_templates in this factory.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns (int) –

the number of pad_templates

#### gst_element_factory_get_skip_documentation

    gboolean
    gst_element_factory_get_skip_documentation (GstElementFactory * factory)

Queries whether registered element managed by factory needs to be excluded from documentation system or not.

Parameters:

`factory` –

a GstElementFactory to query documentation skip

Returns –

TRUE if documentation should be skipped

Since : 1.20

#### Gst.ElementFactory.prototype.get_skip_documentation

    function Gst.ElementFactory.prototype.get_skip_documentation(): {
        // javascript wrapper for 'gst_element_factory_get_skip_documentation'
    }

Queries whether registered element managed by factory needs to be excluded from documentation system or not.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory to query documentation skip

Returns (Number) –

true if documentation should be skipped

Since : 1.20

#### Gst.ElementFactory.get_skip_documentation

    def Gst.ElementFactory.get_skip_documentation (self):
        #python wrapper for 'gst_element_factory_get_skip_documentation'

Queries whether registered element managed by factory needs to be excluded from documentation system or not.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory to query documentation skip

Returns (bool) –

True if documentation should be skipped

Since : 1.20

#### gst_element_factory_get_static_pad_templates

    const GList *
    gst_element_factory_get_static_pad_templates (GstElementFactory * factory)

Gets the GList of GstStaticPadTemplate for this factory.

Parameters:

`factory` –

a GstElementFactory

Returns ( [transfer: none][element-type Gst.StaticPadTemplate]) –

the static pad templates

#### Gst.ElementFactory.prototype.get_static_pad_templates

    function Gst.ElementFactory.prototype.get_static_pad_templates(): {
        // javascript wrapper for 'gst_element_factory_get_static_pad_templates'
    }

Gets the GLib.List of Gst.StaticPadTemplate for this factory.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns ([ Gst.StaticPadTemplate ]) –

the static pad templates

#### Gst.ElementFactory.get_static_pad_templates

    def Gst.ElementFactory.get_static_pad_templates (self):
        #python wrapper for 'gst_element_factory_get_static_pad_templates'

Gets the GLib.List of Gst.StaticPadTemplate for this factory.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns ([ Gst.StaticPadTemplate ]) –

the static pad templates

#### gst_element_factory_get_uri_protocols

    const gchar*const **
    gst_element_factory_get_uri_protocols (GstElementFactory * factory)

Gets a NULL-terminated array of protocols this element supports or NULL if no protocols are supported. You may not change the contents of the returned array, as it is still owned by the element factory. Use g_strdupv to make a copy of the protocol string array if you need to.

Parameters:

`factory` –

a GstElementFactory

Returns ( [transfer: none][array zero-terminated=1]) –

the supported protocols or NULL

#### Gst.ElementFactory.prototype.get_uri_protocols

    function Gst.ElementFactory.prototype.get_uri_protocols(): {
        // javascript wrapper for 'gst_element_factory_get_uri_protocols'
    }

Gets a null-terminated array of protocols this element supports or null if no protocols are supported. You may not change the contents of the returned array, as it is still owned by the element factory. Use GLib.prototype.strdupv to make a copy of the protocol string array if you need to.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns ([ String ]) –

the supported protocols or null

#### Gst.ElementFactory.get_uri_protocols

    def Gst.ElementFactory.get_uri_protocols (self):
        #python wrapper for 'gst_element_factory_get_uri_protocols'

Gets a None-terminated array of protocols this element supports or None if no protocols are supported. You may not change the contents of the returned array, as it is still owned by the element factory. Use GLib.strdupv to make a copy of the protocol string array if you need to.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns ([ str ]) –

the supported protocols or None

#### gst_element_factory_get_uri_type

    GstURIType
    gst_element_factory_get_uri_type (GstElementFactory * factory)

Gets the type of URIs the element supports or GST_URI_UNKNOWN if none.

Parameters:

`factory` –

a GstElementFactory

Returns –

type of URIs this element supports

#### Gst.ElementFactory.prototype.get_uri_type

    function Gst.ElementFactory.prototype.get_uri_type(): {
        // javascript wrapper for 'gst_element_factory_get_uri_type'
    }

Gets the type of URIs the element supports or Gst.URIType.UNKNOWN if none.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns (Gst.URIType) –

type of URIs this element supports

#### Gst.ElementFactory.get_uri_type

    def Gst.ElementFactory.get_uri_type (self):
        #python wrapper for 'gst_element_factory_get_uri_type'

Gets the type of URIs the element supports or Gst.URIType.UNKNOWN if none.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

Returns (Gst.URIType) –

type of URIs this element supports

#### gst_element_factory_has_interface

    gboolean
    gst_element_factory_has_interface (GstElementFactory * factory,
                                       const gchar * interfacename)

Check if factory implements the interface with name interfacename.

Parameters:

`factory` –

a GstElementFactory

`interfacename` –

an interface name

Returns –

TRUE when factory implement the interface.

#### Gst.ElementFactory.prototype.has_interface

    function Gst.ElementFactory.prototype.has_interface(interfacename: String): {
        // javascript wrapper for 'gst_element_factory_has_interface'
    }

Check if factory implements the interface with name interfacename.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

`interfacename` (String) –

an interface name

Returns (Number) –

true when factory implement the interface.

#### Gst.ElementFactory.has_interface

    def Gst.ElementFactory.has_interface (self, interfacename):
        #python wrapper for 'gst_element_factory_has_interface'

Check if factory implements the interface with name interfacename.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

`interfacename` (str) –

an interface name

Returns (bool) –

True when factory implement the interface.

#### gst_element_factory_list_is_type

    gboolean
    gst_element_factory_list_is_type (GstElementFactory * factory,
                                      GstElementFactoryListType type)

Check if factory is of the given types.

Parameters:

`factory` –

a GstElementFactory

`type` –

a GstElementFactoryListType

Returns –

TRUE if factory is of type.

#### Gst.ElementFactory.prototype.list_is_type

    function Gst.ElementFactory.prototype.list_is_type(type: Number): {
        // javascript wrapper for 'gst_element_factory_list_is_type'
    }

Check if factory is of the given types.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

`type` (Number) –

a Number

Returns (Number) –

true if factory is of type.

#### Gst.ElementFactory.list_is_type

    def Gst.ElementFactory.list_is_type (self, type):
        #python wrapper for 'gst_element_factory_list_is_type'

Check if factory is of the given types.

Parameters:

`factory` (Gst.ElementFactory) –

a Gst.ElementFactory

`type` (int) –

a int

Returns (bool) –

True if factory is of type.

### Functions

#### gst_element_factory_find

    GstElementFactory *
    gst_element_factory_find (const gchar * name)

Search for an element factory of the given name. Refs the returned element factory; caller is responsible for unreffing.

Parameters:

`name` –

name of factory to find

Returns ( [transfer: full][nullable]) –

GstElementFactory if found, NULL otherwise

#### Gst.ElementFactory.prototype.find

    function Gst.ElementFactory.prototype.find(name: String): {
        // javascript wrapper for 'gst_element_factory_find'
    }

Search for an element factory of the given name. Refs the returned element factory; caller is responsible for unreffing.

Parameters:

`name` (String) –

name of factory to find

Returns (Gst.ElementFactory) –

Gst.ElementFactory if found, null otherwise

#### Gst.ElementFactory.find

    def Gst.ElementFactory.find (name):
        #python wrapper for 'gst_element_factory_find'

Search for an element factory of the given name. Refs the returned element factory; caller is responsible for unreffing.

Parameters:

`name` (str) –

name of factory to find

Returns (Gst.ElementFactory) –

Gst.ElementFactory if found, None otherwise

#### gst_element_factory_list_filter

    GList *
    gst_element_factory_list_filter (GList * list,
                                     const GstCaps * caps,
                                     GstPadDirection direction,
                                     gboolean subsetonly)

Filter out all the elementfactories in list that can handle caps in the given direction.

If subsetonly is TRUE, then only the elements whose pads templates are a complete superset of caps will be returned. Else any element whose pad templates caps can intersect with caps will be returned.

Parameters:

`list` ( [transfer: none][element-type Gst.ElementFactory]) –

a GList of GstElementFactory to filter

`caps` –

a GstCaps

`direction` –

a GstPadDirection to filter on

`subsetonly` –

whether to filter on caps subsets or not.

Returns ( [transfer: full][element-type Gst.ElementFactory]) –

a GList of GstElementFactory elements that match the given requisites. Use gst_plugin_feature_list_free after usage.

#### Gst.ElementFactory.prototype.list_filter

    function Gst.ElementFactory.prototype.list_filter(list: [ Gst.ElementFactory ], caps: Gst.Caps, direction: Gst.PadDirection, subsetonly: Number): {
        // javascript wrapper for 'gst_element_factory_list_filter'
    }

Filter out all the elementfactories in list that can handle caps in the given direction.

If subsetonly is true, then only the elements whose pads templates are a complete superset of caps will be returned. Else any element whose pad templates caps can intersect with caps will be returned.

Parameters:

`list` ([ Gst.ElementFactory ]) –

a GLib.List of Gst.ElementFactory to filter

`caps` (Gst.Caps) –

a Gst.Caps

`direction` (Gst.PadDirection) –

a Gst.PadDirection to filter on

`subsetonly` (Number) –

whether to filter on caps subsets or not.

Returns ([ Gst.ElementFactory ]) –

a GLib.List of Gst.ElementFactory elements that match the given requisites. Use Gst.PluginFeature.prototype.list_free after usage.

#### Gst.ElementFactory.list_filter

    def Gst.ElementFactory.list_filter (list, caps, direction, subsetonly):
        #python wrapper for 'gst_element_factory_list_filter'

Filter out all the elementfactories in list that can handle caps in the given direction.

If subsetonly is True, then only the elements whose pads templates are a complete superset of caps will be returned. Else any element whose pad templates caps can intersect with caps will be returned.

Parameters:

`list` ([ Gst.ElementFactory ]) –

a GLib.List of Gst.ElementFactory to filter

`caps` (Gst.Caps) –

a Gst.Caps

`direction` (Gst.PadDirection) –

a Gst.PadDirection to filter on

`subsetonly` (bool) –

whether to filter on caps subsets or not.

Returns ([ Gst.ElementFactory ]) –

a GLib.List of Gst.ElementFactory elements that match the given requisites. Use Gst.PluginFeature.list_free after usage.

#### gst_element_factory_list_get_elements

    GList *
    gst_element_factory_list_get_elements (GstElementFactoryListType type,
                                           GstRank minrank)

Get a list of factories that match the given type. Only elements with a rank greater or equal to minrank will be returned. The list of factories is returned by decreasing rank.

Parameters:

`type` –

a GstElementFactoryListType

`minrank` –

Minimum rank

Returns ( [transfer: full][element-type Gst.ElementFactory]) –

a GList of GstElementFactory elements. Use gst_plugin_feature_list_free after usage.

#### Gst.ElementFactory.prototype.list_get_elements

    function Gst.ElementFactory.prototype.list_get_elements(type: Number, minrank: Gst.Rank): {
        // javascript wrapper for 'gst_element_factory_list_get_elements'
    }

Get a list of factories that match the given type. Only elements with a rank greater or equal to minrank will be returned. The list of factories is returned by decreasing rank.

Parameters:

`type` (Number) –

a Number

`minrank` (Gst.Rank) –

Minimum rank

Returns ([ Gst.ElementFactory ]) –

a GLib.List of Gst.ElementFactory elements. Use Gst.PluginFeature.prototype.list_free after usage.

#### Gst.ElementFactory.list_get_elements

    def Gst.ElementFactory.list_get_elements (type, minrank):
        #python wrapper for 'gst_element_factory_list_get_elements'

Get a list of factories that match the given type. Only elements with a rank greater or equal to minrank will be returned. The list of factories is returned by decreasing rank.

Parameters:

`type` (int) –

a int

`minrank` (Gst.Rank) –

Minimum rank

Returns ([ Gst.ElementFactory ]) –

a GLib.List of Gst.ElementFactory elements. Use Gst.PluginFeature.list_free after usage.

#### gst_element_factory_make

    GstElement *
    gst_element_factory_make (const gchar * factoryname,
                              const gchar * name)

Create a new element of the type defined by the given element factory. If name is NULL, then the element will receive a guaranteed unique name, consisting of the element factory name and a number. If name is given, it will be given the name supplied.

Parameters:

`factoryname` –

a named factory to instantiate

`name` ( [nullable]) –

name of new element, or NULL to automatically create a unique name

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if unable to create element

#### Gst.ElementFactory.prototype.make

    function Gst.ElementFactory.prototype.make(factoryname: String, name: String): {
        // javascript wrapper for 'gst_element_factory_make'
    }

Create a new element of the type defined by the given element factory. If name is null, then the element will receive a guaranteed unique name, consisting of the element factory name and a number. If name is given, it will be given the name supplied.

Parameters:

`factoryname` (String) –

a named factory to instantiate

`name` (String) –

name of new element, or null to automatically create a unique name

Returns (Gst.Element) –

new Gst.Element or null if unable to create element

#### Gst.ElementFactory.make

    def Gst.ElementFactory.make (factoryname, name):
        #python wrapper for 'gst_element_factory_make'

Create a new element of the type defined by the given element factory. If name is None, then the element will receive a guaranteed unique name, consisting of the element factory name and a number. If name is given, it will be given the name supplied.

Parameters:

`factoryname` (str) –

a named factory to instantiate

`name` (str) –

name of new element, or None to automatically create a unique name

Returns (Gst.Element) –

new Gst.Element or None if unable to create element

#### gst_element_factory_make_full

    GstElement *
    gst_element_factory_make_full (const gchar * factoryname,
                                   const gchar * first,
                                   ... ...)

Create a new element of the type defined by the given element factory. The supplied list of properties, will be passed at object construction.

Parameters:

`factoryname` –

a named factory to instantiate

`first` ( [nullable]) –

name of first property

`...` ( [nullable]) –

NULL terminated list of properties

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if unable to create element

Since : 1.20

#### gst_element_factory_make_valist

    GstElement *
    gst_element_factory_make_valist (const gchar * factoryname,
                                     const gchar * first,
                                     va_list properties)

Create a new element of the type defined by the given element factory. The supplied list of properties, will be passed at object construction.

Parameters:

`factoryname` –

a named factory to instantiate

`first` ( [nullable]) –

name of first property

`properties` ( [nullable]) –

list of properties

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if unable to create element

Since : 1.20

#### gst_element_factory_make_with_properties

    GstElement *
    gst_element_factory_make_with_properties (const gchar * factoryname,
                                              guint n,
                                              const gchar ** names,
                                              const GValue * values)

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factoryname` –

a named factory to instantiate

`n` –

count of properties

`names` ( [nullable][array length=n]) –

array of properties names

`values` ( [nullable][array length=n]) –

array of associated properties values

Returns ( [transfer: floating][nullable]) –

new GstElement or NULL if the element couldn't be created

Since : 1.20

#### Gst.ElementFactory.prototype.make_with_properties

    function Gst.ElementFactory.prototype.make_with_properties(factoryname: String, n: Number, names: [ String ], values: [ GObject.Value ]): {
        // javascript wrapper for 'gst_element_factory_make_with_properties'
    }

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factoryname` (String) –

a named factory to instantiate

`n` (Number) –

count of properties

`names` ([ String ]) –

array of properties names

`values` ([ GObject.Value ]) –

array of associated properties values

Returns (Gst.Element) –

new Gst.Element or null if the element couldn't be created

Since : 1.20

#### Gst.ElementFactory.make_with_properties

    def Gst.ElementFactory.make_with_properties (factoryname, n, names, values):
        #python wrapper for 'gst_element_factory_make_with_properties'

Create a new element of the type defined by the given elementfactory. The supplied list of properties, will be passed at object construction.

Parameters:

`factoryname` (str) –

a named factory to instantiate

`n` (int) –

count of properties

`names` ([ str ]) –

array of properties names

`values` ([ GObject.Value ]) –

array of associated properties values

Returns (Gst.Element) –

new Gst.Element or None if the element couldn't be created

Since : 1.20

## Function Macros

### GST_ELEMENT_FACTORY_CAST

    #define GST_ELEMENT_FACTORY_CAST(obj)           ((GstElementFactory *)(obj))

## Constants

### GST_ELEMENT_FACTORY_KLASS_DECODER

    #define GST_ELEMENT_FACTORY_KLASS_DECODER               "Decoder"

### Gst.ELEMENT_FACTORY_KLASS_DECODER

### GST_ELEMENT_FACTORY_KLASS_DECRYPTOR

    #define GST_ELEMENT_FACTORY_KLASS_DECRYPTOR             "Decryptor"

### Gst.ELEMENT_FACTORY_KLASS_DECRYPTOR

### GST_ELEMENT_FACTORY_KLASS_DEMUXER

    #define GST_ELEMENT_FACTORY_KLASS_DEMUXER               "Demuxer"

### Gst.ELEMENT_FACTORY_KLASS_DEMUXER

### GST_ELEMENT_FACTORY_KLASS_DEPAYLOADER

    #define GST_ELEMENT_FACTORY_KLASS_DEPAYLOADER           "Depayloader"

### Gst.ELEMENT_FACTORY_KLASS_DEPAYLOADER

### GST_ELEMENT_FACTORY_KLASS_ENCODER

    #define GST_ELEMENT_FACTORY_KLASS_ENCODER               "Encoder"

### Gst.ELEMENT_FACTORY_KLASS_ENCODER

### GST_ELEMENT_FACTORY_KLASS_ENCRYPTOR

    #define GST_ELEMENT_FACTORY_KLASS_ENCRYPTOR             "Encryptor"

### Gst.ELEMENT_FACTORY_KLASS_ENCRYPTOR

### GST_ELEMENT_FACTORY_KLASS_FORMATTER

    #define GST_ELEMENT_FACTORY_KLASS_FORMATTER             "Formatter"

### Gst.ELEMENT_FACTORY_KLASS_FORMATTER

### GST_ELEMENT_FACTORY_KLASS_HARDWARE

    #define GST_ELEMENT_FACTORY_KLASS_HARDWARE              "Hardware"

Elements interacting with hardware devices should specify this classifier in their metadata. You may need to put the element in "READY" state to test if the hardware is present in the system.

Since : 1.16

### Gst.ELEMENT_FACTORY_KLASS_HARDWARE

Elements interacting with hardware devices should specify this classifier in their metadata. You may need to put the element in "READY" state to test if the hardware is present in the system.

Since : 1.16

### Gst.ELEMENT_FACTORY_KLASS_HARDWARE

Elements interacting with hardware devices should specify this classifier in their metadata. You may need to put the element in "READY" state to test if the hardware is present in the system.

Since : 1.16

### GST_ELEMENT_FACTORY_KLASS_MEDIA_AUDIO

    #define GST_ELEMENT_FACTORY_KLASS_MEDIA_AUDIO           "Audio"

### Gst.ELEMENT_FACTORY_KLASS_MEDIA_AUDIO

### GST_ELEMENT_FACTORY_KLASS_MEDIA_IMAGE

    #define GST_ELEMENT_FACTORY_KLASS_MEDIA_IMAGE           "Image"

### Gst.ELEMENT_FACTORY_KLASS_MEDIA_IMAGE

### GST_ELEMENT_FACTORY_KLASS_MEDIA_METADATA

    #define GST_ELEMENT_FACTORY_KLASS_MEDIA_METADATA        "Metadata"

### Gst.ELEMENT_FACTORY_KLASS_MEDIA_METADATA

### GST_ELEMENT_FACTORY_KLASS_MEDIA_SUBTITLE

    #define GST_ELEMENT_FACTORY_KLASS_MEDIA_SUBTITLE        "Subtitle"

### Gst.ELEMENT_FACTORY_KLASS_MEDIA_SUBTITLE

### GST_ELEMENT_FACTORY_KLASS_MEDIA_VIDEO

    #define GST_ELEMENT_FACTORY_KLASS_MEDIA_VIDEO           "Video"

### Gst.ELEMENT_FACTORY_KLASS_MEDIA_VIDEO

### GST_ELEMENT_FACTORY_KLASS_MUXER

    #define GST_ELEMENT_FACTORY_KLASS_MUXER                 "Muxer"

### Gst.ELEMENT_FACTORY_KLASS_MUXER

### GST_ELEMENT_FACTORY_KLASS_PARSER

    #define GST_ELEMENT_FACTORY_KLASS_PARSER                "Parser"

### Gst.ELEMENT_FACTORY_KLASS_PARSER

### GST_ELEMENT_FACTORY_KLASS_PAYLOADER

    #define GST_ELEMENT_FACTORY_KLASS_PAYLOADER             "Payloader"

### Gst.ELEMENT_FACTORY_KLASS_PAYLOADER

### GST_ELEMENT_FACTORY_KLASS_SINK

    #define GST_ELEMENT_FACTORY_KLASS_SINK                  "Sink"

### Gst.ELEMENT_FACTORY_KLASS_SINK

### GST_ELEMENT_FACTORY_KLASS_SRC

    #define GST_ELEMENT_FACTORY_KLASS_SRC                   "Source"

### Gst.ELEMENT_FACTORY_KLASS_SRC

### GST_ELEMENT_FACTORY_TYPE_ANY

    #define GST_ELEMENT_FACTORY_TYPE_ANY ((GstElementFactoryListType)((G_GUINT64_CONSTANT (1) << 49) - 1))

Elements of any of the defined GST_ELEMENT_FACTORY_LIST types

### Gst.ELEMENT_FACTORY_TYPE_ANY

Elements of any of the defined GST_ELEMENT_FACTORY_LIST types

### Gst.ELEMENT_FACTORY_TYPE_ANY

Elements of any of the defined GST_ELEMENT_FACTORY_LIST types

### GST_ELEMENT_FACTORY_TYPE_AUDIOVIDEO_SINKS

    #define GST_ELEMENT_FACTORY_TYPE_AUDIOVIDEO_SINKS ((GstElementFactoryListType)(GST_ELEMENT_FACTORY_TYPE_SINK | GST_ELEMENT_FACTORY_TYPE_MEDIA_AUDIO | GST_ELEMENT_FACTORY_TYPE_MEDIA_VIDEO | GST_ELEMENT_FACTORY_TYPE_MEDIA_IMAGE))

All sinks handling audio, video or image media types

### Gst.ELEMENT_FACTORY_TYPE_AUDIOVIDEO_SINKS

All sinks handling audio, video or image media types

### Gst.ELEMENT_FACTORY_TYPE_AUDIOVIDEO_SINKS

All sinks handling audio, video or image media types

### GST_ELEMENT_FACTORY_TYPE_AUDIO_ENCODER

    #define GST_ELEMENT_FACTORY_TYPE_AUDIO_ENCODER ((GstElementFactoryListType)(GST_ELEMENT_FACTORY_TYPE_ENCODER | GST_ELEMENT_FACTORY_TYPE_MEDIA_AUDIO))

All encoders handling audio media types

### Gst.ELEMENT_FACTORY_TYPE_AUDIO_ENCODER

All encoders handling audio media types

### Gst.ELEMENT_FACTORY_TYPE_AUDIO_ENCODER

All encoders handling audio media types

### GST_ELEMENT_FACTORY_TYPE_DECODABLE

    #define GST_ELEMENT_FACTORY_TYPE_DECODABLE \
      ((GstElementFactoryListType)(GST_ELEMENT_FACTORY_TYPE_DECODER | GST_ELEMENT_FACTORY_TYPE_DEMUXER | GST_ELEMENT_FACTORY_TYPE_DEPAYLOADER | GST_ELEMENT_FACTORY_TYPE_PARSER | GST_ELEMENT_FACTORY_TYPE_DECRYPTOR))

All elements used to 'decode' streams (decoders, demuxers, parsers, depayloaders)

### Gst.ELEMENT_FACTORY_TYPE_DECODABLE

All elements used to 'decode' streams (decoders, demuxers, parsers, depayloaders)

### Gst.ELEMENT_FACTORY_TYPE_DECODABLE

All elements used to 'decode' streams (decoders, demuxers, parsers, depayloaders)

### GST_ELEMENT_FACTORY_TYPE_DECODER

    #define GST_ELEMENT_FACTORY_TYPE_DECODER        ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 0))

### Gst.ELEMENT_FACTORY_TYPE_DECODER

### GST_ELEMENT_FACTORY_TYPE_DECRYPTOR

    #define GST_ELEMENT_FACTORY_TYPE_DECRYPTOR      ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 10))

### Gst.ELEMENT_FACTORY_TYPE_DECRYPTOR

### GST_ELEMENT_FACTORY_TYPE_DEMUXER

    #define GST_ELEMENT_FACTORY_TYPE_DEMUXER        ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 5))

### Gst.ELEMENT_FACTORY_TYPE_DEMUXER

### GST_ELEMENT_FACTORY_TYPE_DEPAYLOADER

    #define GST_ELEMENT_FACTORY_TYPE_DEPAYLOADER    ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 8))

### Gst.ELEMENT_FACTORY_TYPE_DEPAYLOADER

### GST_ELEMENT_FACTORY_TYPE_ENCODER

    #define GST_ELEMENT_FACTORY_TYPE_ENCODER        ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 1))

### Gst.ELEMENT_FACTORY_TYPE_ENCODER

### GST_ELEMENT_FACTORY_TYPE_ENCRYPTOR

    #define GST_ELEMENT_FACTORY_TYPE_ENCRYPTOR      ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 11))

### Gst.ELEMENT_FACTORY_TYPE_ENCRYPTOR

### GST_ELEMENT_FACTORY_TYPE_FORMATTER

    #define GST_ELEMENT_FACTORY_TYPE_FORMATTER      ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 9))

### Gst.ELEMENT_FACTORY_TYPE_FORMATTER

### GST_ELEMENT_FACTORY_TYPE_HARDWARE

    #define GST_ELEMENT_FACTORY_TYPE_HARDWARE      ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 12))

### Gst.ELEMENT_FACTORY_TYPE_HARDWARE

### GST_ELEMENT_FACTORY_TYPE_MAX_ELEMENTS

    #define GST_ELEMENT_FACTORY_TYPE_MAX_ELEMENTS   ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 48))

### Gst.ELEMENT_FACTORY_TYPE_MAX_ELEMENTS

### GST_ELEMENT_FACTORY_TYPE_MEDIA_ANY

    #define GST_ELEMENT_FACTORY_TYPE_MEDIA_ANY ((GstElementFactoryListType)(~G_GUINT64_CONSTANT (0) << 48))

Elements matching any of the defined GST_ELEMENT_FACTORY_TYPE_MEDIA types

Note: Do not use this if you wish to not filter against any of the defined media types. If you wish to do this, simply don't specify any GST_ELEMENT_FACTORY_TYPE_MEDIA flag.

### Gst.ELEMENT_FACTORY_TYPE_MEDIA_ANY

Elements matching any of the defined GST_ELEMENT_FACTORY_TYPE_MEDIA types

Note: Do not use this if you wish to not filter against any of the defined media types. If you wish to do this, simply don't specify any GST_ELEMENT_FACTORY_TYPE_MEDIA flag.

### Gst.ELEMENT_FACTORY_TYPE_MEDIA_ANY

Elements matching any of the defined GST_ELEMENT_FACTORY_TYPE_MEDIA types

Note: Do not use this if you wish to not filter against any of the defined media types. If you wish to do this, simply don't specify any GST_ELEMENT_FACTORY_TYPE_MEDIA flag.

### GST_ELEMENT_FACTORY_TYPE_MEDIA_AUDIO

    #define GST_ELEMENT_FACTORY_TYPE_MEDIA_AUDIO    ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 50))

### Gst.ELEMENT_FACTORY_TYPE_MEDIA_AUDIO

### GST_ELEMENT_FACTORY_TYPE_MEDIA_IMAGE

    #define GST_ELEMENT_FACTORY_TYPE_MEDIA_IMAGE    ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 51))

### Gst.ELEMENT_FACTORY_TYPE_MEDIA_IMAGE

### GST_ELEMENT_FACTORY_TYPE_MEDIA_METADATA

    #define GST_ELEMENT_FACTORY_TYPE_MEDIA_METADATA ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 53))

### Gst.ELEMENT_FACTORY_TYPE_MEDIA_METADATA

### GST_ELEMENT_FACTORY_TYPE_MEDIA_SUBTITLE

    #define GST_ELEMENT_FACTORY_TYPE_MEDIA_SUBTITLE ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 52))

### Gst.ELEMENT_FACTORY_TYPE_MEDIA_SUBTITLE

### GST_ELEMENT_FACTORY_TYPE_MEDIA_VIDEO

    #define GST_ELEMENT_FACTORY_TYPE_MEDIA_VIDEO    ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 49))

### Gst.ELEMENT_FACTORY_TYPE_MEDIA_VIDEO

### GST_ELEMENT_FACTORY_TYPE_MUXER

    #define GST_ELEMENT_FACTORY_TYPE_MUXER          ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 4))

### Gst.ELEMENT_FACTORY_TYPE_MUXER

### GST_ELEMENT_FACTORY_TYPE_PARSER

    #define GST_ELEMENT_FACTORY_TYPE_PARSER         ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 6))

### Gst.ELEMENT_FACTORY_TYPE_PARSER

### GST_ELEMENT_FACTORY_TYPE_PAYLOADER

    #define GST_ELEMENT_FACTORY_TYPE_PAYLOADER      ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 7))

### Gst.ELEMENT_FACTORY_TYPE_PAYLOADER

### GST_ELEMENT_FACTORY_TYPE_SINK

    #define GST_ELEMENT_FACTORY_TYPE_SINK           ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 2))

### Gst.ELEMENT_FACTORY_TYPE_SINK

### GST_ELEMENT_FACTORY_TYPE_SRC

    #define GST_ELEMENT_FACTORY_TYPE_SRC            ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 3))

### Gst.ELEMENT_FACTORY_TYPE_SRC

### GST_ELEMENT_FACTORY_TYPE_TIMESTAMPER

    #define GST_ELEMENT_FACTORY_TYPE_TIMESTAMPER    ((GstElementFactoryListType)(G_GUINT64_CONSTANT (1) << 13))

Timestamp correcting elements

Since : 1.24

### Gst.ELEMENT_FACTORY_TYPE_TIMESTAMPER

Timestamp correcting elements

Since : 1.24

### Gst.ELEMENT_FACTORY_TYPE_TIMESTAMPER

Timestamp correcting elements

Since : 1.24

### GST_ELEMENT_FACTORY_TYPE_VIDEO_ENCODER

    #define GST_ELEMENT_FACTORY_TYPE_VIDEO_ENCODER ((GstElementFactoryListType)(GST_ELEMENT_FACTORY_TYPE_ENCODER | GST_ELEMENT_FACTORY_TYPE_MEDIA_VIDEO | GST_ELEMENT_FACTORY_TYPE_MEDIA_IMAGE))

All encoders handling video or image media types

### Gst.ELEMENT_FACTORY_TYPE_VIDEO_ENCODER

All encoders handling video or image media types

### Gst.ELEMENT_FACTORY_TYPE_VIDEO_ENCODER

All encoders handling video or image media types

## Aliases

### GstElementFactoryListType

    typedef guint64 GstElementFactoryListType

A type defining the type of an element factory.

The results of the search are